#pragma semicolon 1

#include <sourcemod>
#include <cstrike>

public Plugin:myinfo = 
{
	name = "Spawn_Time_Control",
	author = "wS / Schmidt",
	description = "Время после старта раунда, в течение которого можно вступить в игру живым",
	version = "1.1",
	url = "http://world-source.ru/"
};

new Handle:stc_sec, Handle:TIMER, Handle:MyTimer[MAXPLAYERS+1];

public OnPluginStart()
{
	stc_sec = CreateConVar("stc_sec", "10.0", "Время после старта раунда, в течение которого можно вступить в игру живым", FCVAR_NOTIFY, true, 1.0);
	CreateConVar("Spawn_Time_Control", "1.1", "Spawn_Time_Control version [ Plugin by wS ]", FCVAR_NOTIFY);
	HookEvent("round_start", round_start, EventHookMode_PostNoCopy);
	HookEvent("player_team", player_team);
}

///

public round_start(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (TIMER != INVALID_HANDLE) KillTimer(TIMER);
	TIMER = CreateTimer(GetConVarFloat(stc_sec), BlockSpawnCallBack);
}

public Action:BlockSpawnCallBack(Handle:timer) TIMER = INVALID_HANDLE;

///

public player_team(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetEventInt(event, "team") > 1)
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		if (!IsFakeClient(client))
		{
			if (MyTimer[client] != INVALID_HANDLE) KillTimer(MyTimer[client]);
			MyTimer[client] = CreateTimer(0.5, player_teamCallBack, client, TIMER_FLAG_NO_MAPCHANGE);
		}
	}
}

public Action:player_teamCallBack(Handle:timer, any:client)
{
	MyTimer[client] = INVALID_HANDLE;
	if (IsClientInGame(client) && FoundAliveEnemy(client))
	{
		if (IsPlayerAlive(client))
		{
			if (TIMER == INVALID_HANDLE) ChangeClientTeam(client, 1);
		}
		else if (TIMER != INVALID_HANDLE) CS_RespawnPlayer(client);
	}
}

bool:FoundAliveEnemy(client)
{
	new team = GetClientTeam(client);
	if (team > 1)
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (i != client && IsClientInGame(i) && IsPlayerAlive(i) && GetClientTeam(i) != team) return true;
		}
	}
	return false;
}

// wS